
//порты для каналов в content.js
var g_content_ports = {};
//порты для канала в native.npxcrypt.host
var g_native_ports = {};

function getPortId(msg)
{
  var dest = msg.data.destination;
  return msg.tabid
}

function sendNativeMessage(msg) {
  try {
      var id_p = getPortId(msg)
      if(!g_native_ports[id_p])
          connect(id_p, msg.data.destination == "updater"?"com.native.npxcrypt.updater":undefined);
      g_native_ports[msg.tabid].postMessage(msg);
      //console.log("Sent native message:" + JSON.stringify(msg));
  }
  catch(err){
      console.warn("Excetion on sending NativeMessage " + err.message);
      g_native_ports[msg.tabid] = null;
      var err_message = {tabid: msg.tabid, data: {requestid: msg.data.requestid,
                          message: "Error sending message to Native Host",
                          type: "error"}};
      g_content_ports[message.tabid].postMessage(err_message);
  }
}

function onNativeMessage(message) {
    try {
        //console.log("Received native message:" + JSON.stringify(message));
        if (message.partial) {
            if (message.partial == 1) {
                g_message_collector[message.tabid] = message.part;
                console.log("Received native message begin");
                return;
            }
            if (message.partial > 1) {
                g_message_collector[message.tabid] += message.part;
                console.log("Received native message next part");
                return;
            }
            if (message.partial == -1) {
                g_message_collector[message.tabid] += message.part;
                console.log("Received native message end");
                g_content_ports[message.tabid].postMessage(JSON.parse(g_message_collector[message.tabid]));
                g_message_collector[message.tabid] = "";
                return;
            }
        }
        g_content_ports[message.tabid].postMessage(message);

    } catch (err) {
        console.warn("Exception on sending message to content page " + err.message);
        g_content_ports[message.tabid] = null;
        //TODO:SendError message
    }
}

function connect(tabid,hostName) {
  if (hostName === undefined) {
    hostName = "com.native.npxcrypt.host";
  }
  console.log("Connecting to native messaging host" + hostName)
  g_native_ports[tabid] = browser.runtime.connectNative(hostName);
  g_native_ports[tabid].onMessage.addListener(onNativeMessage);
  g_native_ports[tabid].onDisconnect.addListener(function () {
      console.log("Disconnect Event: " + browser.runtime.lastError.message + " tabid " + tabid);
      g_native_ports[tabid] = null;
      if(g_content_ports[tabid])
          g_content_ports[tabid].postMessage({"tabid":tabid,"data":{"type":"hosterror","message":browser.runtime.lastError.message}});
          g_content_ports[tabid].disconnect();
      g_content_ports[tabid] = null;
  });
  return true;
}

browser.runtime.onConnect.addListener(function(_content_port) {
        console.log("Connected from tabid:" + _content_port.name);
        g_content_ports[_content_port.name] = _content_port;
        _content_port.onMessage.addListener(function(msg) {
            sendNativeMessage(msg);
        });
        _content_port.onDisconnect.addListener(function() {
            g_content_ports[_content_port.name] = null;
            if(g_native_ports[_content_port.name])
                g_native_ports[_content_port.name].disconnect();
            g_native_ports[_content_port.name] = null;
        });
});
