;( function () {
    var chrome_nmxcrypt = {}
    function async_spawn(generatorFunc) {
        function continuer(verb, arg) {
            var result;
            try {
                result = generator[verb](arg);
            } catch (err) {
                return Promise.reject(err);
            }
            if (result.done) {
                return result.value;
            } else {
                return Promise.resolve(result.value).then(onFulfilled, onRejected);
            }
        }
        var generator = generatorFunc(Array.prototype.slice.call(arguments, 1));
        var onFulfilled = continuer.bind(continuer, "next");
        var onRejected = continuer.bind(continuer, "throw");
        return onFulfilled();
    }
    chrome_nmxcrypt.async_spawn = async_spawn;

    function Print2Digit(digit) {
        return (digit < 10) ? "0" + digit : digit;
    }

    function DateToUTCStr(d) {
        var ret = d.getFullYear() + "-";
        ret = ret + Print2Digit(d.getMonth() + 1);
        ret = ret + "-";
        ret = ret + Print2Digit(d.getUTCDate()) + "T";
        ret = ret + Print2Digit(d.getUTCHours()) + ":" + Print2Digit(d.getUTCMinutes()) + ":" + Print2Digit(d.getUTCSeconds()) + ".";
        var ms = d.getUTCMilliseconds();
        if (ms < 100) {
            if (ms < 10)
                ms = "00" + ms;
            else
                ms = "0" + ms;
        }
        ret = ret + ms + "Z";
        return ret;
    }

    //значения функций для обслуживания Promise
    var g_resolve_function = {};
    var g_reject_function = {};
    var g_request_id = 1;

    function Json_to_javascript(data) {
        if (data.retval.type == "object") {
            obj = {};
            obj['objid'] = data.retval.value;
            if (typeof data.retval.properties == "object") {
                var props = data.retval.properties;
                for (var i = 0; i < props.length; i++) {
                    //                Object.defineProperty(obj, props[i], {get : CallGetProperty.bind(obj, props[i]),
                    //                                                      set : CallSetProperty.bind(obj, props[i])});
                    Object.defineProperty(obj, props[i], {
                        get: CallGetProperty.bind(obj, props[i])
                    });
                    obj["propset_" + props[i]] = CallSetProperty.bind(obj, props[i]);
                }
            }
            if (typeof data.retval.methods == "object") {
                var methods = data.retval.methods;
                for (var i = 0; i < methods.length; i++) {
                    obj[methods[i]] = CallMethod.bind(obj, methods[i]);
                }

            }
            return obj;
        }
        if (data.retval.type == "string") {
            return data.retval.value;
        }
        if (data.retval.type == "number") {
            return parseInt(data.retval.value);
        }
        if (data.retval.type == "boolean") {
            return Boolean(data.retval.value);
        }
        if (data.retval.type == "OK") {
            return;
        }
    }

    function CallMethod() {
        //create message structure
        g_request_id++;
        args = new Array();
        var arg;
        for (var i = 1; i < arguments.length; i++) {
            if (typeof arguments[i] == "object") {
                if (arguments[i] instanceof Date) {
                    arg = {
                        type: "string",
                        value: DateToUTCStr(arguments[1])
                    };
                    args.push(arg);
                    continue;
                }
                arg = {
                    type: typeof arguments[i],
                    value: arguments[i]["objid"]
                };
                args.push(arg);
                continue;
            }
            arg = {
                type: typeof arguments[i],
                value: arguments[i]
            };
            args.push(arg);
        }
        object_messsage = {
            destination: (arguments[0] == "Update" ? "updater" : "nmxcrypt"),
            requestid: g_request_id,
            objid: this["objid"],
            method: arguments[0],
            params: args
        };
        console.log("api:CallMethod:", object_messsage)
        var requestPromise = new Promise(function(resolve, reject) {
            g_resolve_function[g_request_id] = resolve;
            g_reject_function[g_request_id] = reject;
            window.postMessage(object_messsage, "*");
        });
        return requestPromise.then(function(result) {
            return Json_to_javascript(result.data);
        });
    }

    function CreatePluginObject() {
        obj = {};
        obj['objid'] = '0';
        obj.GetVersion = CallMethod.bind(obj, "GetVersion");
        obj.DeleteArchive = CallMethod.bind(obj, "DeleteArchive");
        obj.SelectCertificate = CallMethod.bind(obj, "SelectCertificate");
        obj.TestCades = CallMethod.bind(obj, "TestCades");
        obj.Sign = CallMethod.bind(obj, "Sign");
        obj.DownloadFile = CallMethod.bind(obj, "DownloadFile");
        obj.SignFileWeb = CallMethod.bind(obj, "SignFileWeb");
        obj.Hash = CallMethod.bind(obj, "Hash");
        obj.Update = CallMethod.bind(obj, "Update");

        return obj;
    }

    chrome_nmxcrypt.CreatePluginObject = CreatePluginObject;

    function windowListner(event) {
        if (event.source != window)
            return;
        if (event.data.tabid) {
            if (event.data.data.type == "result")
                g_resolve_function[event.data.data.requestid](event.data);
            else if (event.data.data.type == "error")
                g_reject_function[event.data.data.requestid](event.data.data);
            else if (event.data.data.type == "hosterror"){
                Object.keys(g_reject_function).forEach(function(request_id, index_f) {
                    g_reject_function[request_id](event.data.data);
                });
            }
        }
    }
    window.addEventListener("message", windowListner, false);
    window.chrome_nmxcrypt = chrome_nmxcrypt;
})();